#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines
#include <ddraw.h>	// directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>


#include "world.h"
#include "tank.h"
#include "projectile.h"
#include "main.h"
#include "explosion.h"

explosion::explosion() {

}

explosion::explosion(int *terrain_y, weaponType wpn, int x, int y, int r, int plyr) {
	pos_x = x;
	pos_y = y;
	wpnType = wpn;
	player = plyr;
	counter = 0;
	terrain = terrain_y;
	radius = r;
}

bool explosion::draw() {
//Returns true if done exploding
	switch(getWpn()) {
			//MISSILE=0, LGMISSILE, NUKE, BOUNCY, CLUSTER, MEGACLUSTER, VICKS, HERBS, LASER, DIGGER, LGDIGGER, SANDBLAST, LGSANDBLAST, AIRSTRIKE, PARTICLE
		case MISSILE:
		case LGMISSILE:
		case NUKE:
		case LGNUKE:
		case CLUSTER:
		case MEGACLUSTER:
		case DIGGER:
		case LGDIGGER:
		case LASER:
		case VICKS:
		case HERBS:
			return drawCircularExplosion();
			break;
		default:		return true;
	};
	return true;
}

bool explosion::drawCircularExplosion() {
//	returns true if done exploding
	
	HBRUSH brush;
	if(counter % 2 == 0)
		brush = CreateSolidBrush(RGB(255,0,0));
	else
		brush = CreateSolidBrush(RGB(255,255,0));

	SelectObject(hdc,brush);

	if(counter < radius) {
		drawCircle(pos_x,pos_y,counter);	
		updateTerrainCircleExplosion(counter);
		counter +=5;
		return false;
	}
	return true;

}

void explosion::drawCircle(int x, int y, int r) {
	Ellipse(hdc,x-r,y-r,x+r,y+r);
	
}

weaponType explosion::getWpn() {
	return wpnType;
}

int explosion::getPlayer() {
	return player;
}
int explosion::getX() {
	return pos_x;
}

int explosion::getY() {
	return pos_y;
}

int explosion::getR() {
	return radius;
}

void explosion::updateTerrainCircleExplosion(int r){
	int y, x;

	for(x=0; x<=r; x++) {
		y=r * sin(acos(double(x)/double(r)));	

		if((terrain[pos_x-x] < pos_y-y) && (pos_x -x >= 0))
			terrain[pos_x-x] = terrain[pos_x-x] + y*2;
		else if((terrain[pos_x-x] <pos_y+y) && (pos_x -x >= 0))
				terrain[pos_x-x] += (pos_y+y) - terrain[pos_x-x];

		if((terrain[pos_x+x] < pos_y-y) && (pos_x + x < MAP_W))
			terrain[pos_x+x] = terrain[pos_x+x] + y*2;
		else if((terrain[pos_x+x] <pos_y+y) && (pos_x + x < MAP_W))
			terrain[pos_x+x] += (pos_y+y) - terrain[pos_x+x];

		if(terrain[pos_x-x] > MAP_H && (pos_x - x >= 0))
				terrain[pos_x-x] = MAP_H;
		if(terrain[pos_x+x] > MAP_H && (pos_x + x < MAP_W))
				terrain[pos_x+x] = MAP_H;
	}
}