/*
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
				TANK WARFARE
					By
		Maxim Mass and Jeff Lundbergh
			CIS487: Game Design
				Fall 2002
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
*/

//To compile make sure to include these in the linker config:
//kernel32.lib user32.lib gdi32.lib winspool.lib 
//comdlg32.lib advapi32.lib shell32.lib  uuid.lib 
//ddraw.lib dsound.lib dinput.lib winmm.lib d3d8.lib dinput8.lib 


///////////////////////////////////
//   INCLUDES
///////////////////////////////////

#define INITGUID
#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines								//
#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "main.h"
#include "main_menu.h"

///////////////////////////////////
//   GLOBALS
///////////////////////////////////
HWND main_window_handle;	// save the window handle
HINSTANCE main_instance;	// save the instance
char buffer[256];           // used to print text
HDC hdc;					// hardware device context
world *TankWarfare = NULL;	// global world class pointer
int MOUSE_X;				// Mouse X location
int MOUSE_Y;				// Mouse Y location
int buttons;				// Mouse buttons pressed
sound *worldSounds = NULL;	// global sound class pointer
vector<tank> tankList;		// Global list of tanks
enum gameStateType			// Global game state
{INTRO, BUY_WPN, BATTLE, END};
gameStateType gameState = INTRO;

///////////////////////////////////
// Function Prototypes	
///////////////////////////////////
void initializeTanks(int num_players);

///////////////////////////////////
// Functions Prototypes	
///////////////////////////////////
LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT	ps;		   // used in WM_PAINT
//HDC			hdc;	   // handle to a device context

// what is the message 
switch(msg)
	{
	case WM_COMMAND:
	 {
	  switch(LOWORD(wparam))
		{
		// handle the FILE menu
		case MENU_FILE_ID_NEW2:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world(); //Instantiate world
					 }

					 initializeTanks(2);			//Initialize tanks
					 TankWarfare->create();			//Start the world	 
				 }
		     } break;
		case MENU_FILE_ID_NEW3:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(3);
					 TankWarfare->create();				 
				 }
		     } break;
		case MENU_FILE_ID_NEW4:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(4);
					 TankWarfare->create();
				 }
		     } break;
		case MENU_FILE_ID_NEW5:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(5);
					 TankWarfare->create();
				 }
		     } break;
		case MENU_FILE_ID_NEW6:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(6);
					 TankWarfare->create();
				 }
		     } break;
		case MENU_FILE_ID_NEW7:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(7);
					 TankWarfare->create();
				 }
		     } break;
		case MENU_FILE_ID_NEW8:
		     {
				 if(gameState == INTRO){
					 // start a new game
					 if(!TankWarfare){
						TankWarfare = new world();
					 }
					 initializeTanks(8);
					 TankWarfare->create();
				 }
		     } break;


		case MENU_FILE_ID_QUIT:
		     {
				 // go to intro
				 gameState = INTRO;
				 worldSounds->stopSound(BG_SOUND);
		     } break;

		case MENU_FILE_ID_EXIT:
		     {
				 // terminate window
				 PostQuitMessage(0);
		     } break;

		// handle the HELP menu
		case MENU_HELP_ABOUT:		 
		     {
				 //  pop up a message box
				 MessageBox(hwnd, "Menu Sound Demo", 
					   "About Sound Menu",
					MB_OK | MB_ICONEXCLAMATION);
		     } break;

		default: break;

	     } // end switch wparam

	  } break; // end WM_COMMAND



	case WM_CREATE: 
        {
		// do initialization stuff here
		return(0);
		} break;

	case WM_LBUTTONDOWN: //Get every mouse action
	case WM_LBUTTONUP:
	case WM_MOUSEMOVE:
		{
			// get the position of the mouse
			MOUSE_X = (int)LOWORD(lparam);
			MOUSE_Y = (int)HIWORD(lparam);

			// get the button state
			buttons = (int)wparam;

			ReleaseDC(hwnd, hdc);
			break;
		}

	case WM_PAINT:
         {
         // start painting
         hdc = BeginPaint(hwnd,&ps);

         // end painting
         EndPaint(hwnd,&ps);
         return(0);
        } break;

	case WM_DESTROY: 
		{
		// kill the application			
		PostQuitMessage(0);
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{
// this is the winmain function
WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
//HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(hinstance, MAKEINTRESOURCE(ICON_TANKWARFARE));
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(hinstance, MAKEINTRESOURCE(ICON_TANKWARFARE));

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    WINDOW_TITLE, // title
						    //1,
							(1 ? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION) : (WS_POPUP | WS_VISIBLE)), 
					 	    0,0,	  // initial x,y
						    MAP_W,MAP_H,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

HMENU hmenuhandle = LoadMenu(hinstance, "SoundMenu");
SetMenu(hwnd, hmenuhandle);

// save main window handle
main_window_handle = hwnd;

// now resize the window, so the client area is the actual size requested
// since there may be borders and controls if this is going to be a windowed app
// if the app is not windowed then it won't matter
RECT window_rect = {0,0,MAP_W-1,MAP_H-1};

// make the call to adjust window_rect
AdjustWindowRectEx(&window_rect,
     GetWindowStyle(main_window_handle),
     GetMenu(main_window_handle) != NULL,
     GetWindowExStyle(main_window_handle));

// save the global client offsets, they are needed in DDraw_Flip()
window_client_x0 = -window_rect.left;
window_client_y0 = -window_rect.top;

// now resize the window with a call to MoveWindow()
MoveWindow(main_window_handle,
           0, // x position
           0, // y position
           window_rect.right - window_rect.left, // width
           window_rect.bottom - window_rect.top, // height
           TRUE);

// show the window, so there's no garbage on first render
ShowWindow(main_window_handle, SW_SHOW);

//////////////////////////////////////////
//            INITIALIZATION            //
//////////////////////////////////////////
int numberOfPlayers = 3;
int roundsPlayed =0;

if(!worldSounds) //Instantiate a sound class
	worldSounds = new sound();

weaponBuy buyScreen; //create a buyscreen class


//////////////////////////////////////////
//            Initialize Intro screen   //
//////////////////////////////////////////
	worldSounds->playSound(BG_SOUND,false,TRUE);

	DDraw_Init(MAP_W, MAP_H, 16, 1);
	
	//create & load the bitmap file
	BITMAP_FILE introFile;
	Load_Bitmap_File(&introFile, "graphics/intro.bmp"); //load the file
	//create the bitmap image
	BITMAP_IMAGE introImage;
	Create_Bitmap(&introImage, 0,0,800,600,16);

		//load the bitmap file into image
	Load_Image_Bitmap16(&introImage, &introFile, 0,0, BITMAP_EXTRACT_MODE_ABS);
	Unload_Bitmap_File(&introFile);

	DDraw_Lock_Back_Surface();

//////////////////////////////////////////
//            MAIN GAME LOOP            //
//////////////////////////////////////////
while(1){
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)){ 
		if(msg.message == WM_QUIT)
			break; //Stop the loop!

		TranslateMessage(&msg); // translate any accelerator keys
		// send the message to the window proc
		DispatchMessage(&msg);
		} // end if
	
	switch (gameState) {
	case BATTLE: //In the battle screen
		if(TankWarfare){
				if(TankWarfare->updateScreen()){ //Battle is over?
					roundsPlayed++;					
					if(roundsPlayed < NUMBER_OF_ROUNDS){ //10 Rounds
						gameState = BUY_WPN; //Move state to the buy screen
						buyScreen.initialize();
						worldSounds->playSound(BG_SOUND,false,true);
					}
					else
						gameState = END;	//all rounds played
			}
		}
			break;
	case BUY_WPN:
		if(buyScreen.updateScreen()) {
				TankWarfare->create(); //Reinitialize the world
				worldSounds->stopSound(BG_SOUND);
				gameState = BATTLE;
		}
			break;
	case INTRO: //Display the intro picture
				Start_Clock();
				DDraw_Fill_Surface(lpddsback, 0);
				DDraw_Lock_Back_Surface();
				Draw_Bitmap16(&introImage,back_buffer,back_lpitch,0);
				DDraw_Unlock_Back_Surface();
				DDraw_Flip();
				Wait_Clock(100);
				break;
	
	case END:
			//Quit the program
			PostMessage(main_window_handle, WM_DESTROY,0,0);
			break;

	};
	
	


} // end while


// return to Windows
return(msg.wParam);

} // end WinMain


void initializeTanks(int num_players) {
//Initialize num_tanks tanks in the tankList vector
	worldSounds->stopSound(BG_SOUND);

	gameState	= BATTLE;
	tankList.clear();//Clear the list of tanks.

	//random colors of tanks
	int random_color;
	int color_list[8];	//list of available colors (1 = taken)
	int color;

	for(int i=0; i<8; i++)
		color_list[i] = 0;

	for(i=0; i<num_players; i++) { //For every tank
		do{	//find a random color that hasn't been used yet
			random_color = RAND_RANGE(0,7);
			if (color_list[random_color] != 1){
				color = random_color;
				color_list[random_color] = 1;
				break;
			}
		}while(1);

		//add a tank
		tank newTank(color);
		tankList.push_back(newTank);

		//set the name of the tank
		switch(color) {
		case RED :			
					tankList[i].name = "Red";
					break;
		case GREEN :			
					tankList[i].name = "Green";
					break;
		case YELLOW :			
					tankList[i].name = "Yellow";
					break;
		case ORANGE :			
					tankList[i].name = "Orange";
					break;
		case GREY :			
					tankList[i].name = "Grey";
					break;
		case PURPLE :			
					tankList[i].name = "Purple";
					break;
		case CYAN :			
					tankList[i].name = "Cyan";
					break;
		case BLUE :			
					tankList[i].name = "Blue";
					break;

		};
	}
}