#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines
#include <ddraw.h>	// directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>


#include "world.h"
#include "tank.h"
#include "projectile.h"



/////////////////////////////////////////////////////////////
/*
projectile::projectile(int x, int y, int velocity, int angle,
					   int owner_tank, weaponType type, int x_target, int y_target){

	target_x = x_target;
	target_y = y_target;
	projectile(x, y, velocity, angle, owner_tank, type);
}


*/
projectile::projectile(int x, int y, int velocity, int angle,
					   int owner_tank, weaponType type, int x_target, int y_target){

	angle = 180 - angle;
	x_pos = x;
	y_pos = y;
	x_velocity = velocity * cos(angle*PI/180.0);
	y_velocity = velocity * sin(angle*PI/180.0) * -1;
	owner = owner_tank;
	weapon_type = type;
	//draw_state = 0;
	start_time = 0;
	target_x = x_target;
	target_y = y_target;


	switch(type){ //MISSILE, LGMISSILE, NUKE, BOUNCY, CLUSTER, MEGACLUSTER, VICKS, HERBS, LASER, DIGGER, LGDIGGER, SANDBLAST, LGSANDBLAST, AIRSTRIKE, PARTICLE
		case MISSILE:

							//load the image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 25;
						radius = 25;
						break;

		case LGMISSILE:		//load the large missile image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);
						
							//set the damage
						damage = 50;
						radius = 50;
						break;

		case NUKE:			//load the nuke image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);
							
							//set the damage
						damage = 100;
						radius = 75;
						break;

		case LGNUKE:		//load the large nuke image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);
							
							//set the damage
						damage = 100;
						radius = 150;
						break;

		case CLUSTER:	//load the megacluster image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 25;
						radius = 25;
						break;

		case MEGACLUSTER:	//load the megacluster image
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 50;
						radius = 35;
						break;

		case VICKS:			//vertical guidence system
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 25;
						radius = 25;
						break;

		case HERBS:			//horizontal guidence system
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 25;
						radius = 25;
						break;

		case LASER:			//instantaneous stream of energy not affected by GRAVITY
						Load_Bitmap_File(&bitmap_file, "particle_red.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,1,1,16);

							//set the damage
						damage = 75;
						radius = 20;
						break;

		case DIGGER:
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 0;
						radius = 25;
						break;
		case LGDIGGER:
						Load_Bitmap_File(&bitmap_file, "graphics/missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,6,6,16);

							//set the damage
						damage = 0;
						radius = 50;
						break;

		case PARTICLE:
						switch(RAND_RANGE(1,5)){	//load a random particle file
							case 1: Load_Bitmap_File(&bitmap_file, "graphics/particle_yellow.bmp");
									break;
							case 2: Load_Bitmap_File(&bitmap_file, "graphics/particle_red.bmp");
									break;
							case 3: Load_Bitmap_File(&bitmap_file, "graphics/particle_yellow.bmp");
									break;
							case 4: Load_Bitmap_File(&bitmap_file, "graphics/particle_pink.bmp");
									break;
							case 5: Load_Bitmap_File(&bitmap_file, "graphics/particle_black.bmp");
									break;
						}
						
						Create_Bitmap(&projectile_image, x_pos,y_pos,1,1,16);

						damage = 0;
						radius = 0;
						break;

		default:			//load the default weapon image
						Load_Bitmap_File(&bitmap_file, "missile.bmp"); //load the file
						Create_Bitmap(&projectile_image, x_pos,y_pos,5,5,16);

						damage = 0;
						radius = 0;
						break;
	
	}

	Load_Image_Bitmap16(&projectile_image, &bitmap_file, 0,0, BITMAP_EXTRACT_MODE_ABS);

	//Play a projectile flying sound, replicate it.
	//if((type != PARTICLE) && (type != LASER))
	//	sound_id = worldSounds->playSound(PROJECTILE_FLY,true);

}
/////////////////////////////////////////////////////////////
int projectile::get_x(){
	return x_pos;
}

int projectile::get_y(){
	return y_pos;
}

int projectile::get_vx(){
	return x_velocity;
}

int projectile::get_vy(){
	return y_velocity;
}

int projectile::get_damage(){
	return damage;
}

int projectile::get_radius(){
	return radius;
}

int projectile::get_owner(){
	return owner;
}

weaponType projectile::getWeaponType() {
	return weapon_type;
}
/////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
void projectile::set_x(int x){
	x_pos = x;
}

void projectile::set_y(int y){
	y_pos = y;
}

void projectile::set_vx(int vx){
	x_velocity = vx;
}

void projectile::set_vy(int vy){
	y_velocity = vy;
}

void projectile::set_dammage(int damge){
	damage = damge;
}

void projectile::set_radius(int r){
	radius = r;
}
/////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
/*
	The move function will move the projectile based on it's
	current velocity.  It will then update the velocity based
	on gravity.

	Return: 1 if there is a colision
			-1 if the projectile is off screen
			0 otherwise
*/


int projectile::move(int terrain[]){

	int collision = 0;
	int x_velocity_halfed = x_velocity;
	int y_velocity_halfed = y_velocity;


	double old_x = (double)x_pos;		//save the previous point
	double old_y = (double)y_pos;
	double x, y, m;
	int i=0;
	//float change_in_time;                                        

		//move the projectile


		//apply guidance
	if(weapon_type == VICKS){
			//apply vertical guidance
		if(y_pos < target_y)
			y_pos += 20;

		x_pos += x_velocity/2;
		y_pos += y_velocity/2;
		y_velocity += 1;
	}
 	else if(weapon_type == HERBS){
			//apply horizontal guidance
		x_pos += x_velocity/2;
		if(x_pos < target_x)
			x_pos += 10;
		else
			x_pos -= 10;
		y_pos += y_velocity/2;
	}
	else{
			//no guidance
		x_pos += x_velocity/2;
		y_pos += y_velocity/2;
	}

		//apply gravity
	if(weapon_type != LASER && weapon_type != VICKS)
		y_velocity += GRAVITY;
		//apply random y to machine gun
	y_pos += RAND_RANGE(0, 10);


		//check for collisions during move
	if(x_pos > old_x){
		for(x = old_x; x <= x_pos; x++){
			m = (y_pos - old_y)/(x_pos - old_x);	//slope of line
			y = m * x + (old_y - m * old_x);		//y for given x
			if(x < MAP_W - projectile_image.width && x > 0){
				if(terrain[(int)x] <= y){
						//collision has occured durring move
					collision = 1;
					x_pos = (int)x;
					y_pos = (int)y;

					return 1; //collision
				}
			}
			else return -1; //out of bounds
		}
	}
	else if(x_pos < old_x){
		for(x = old_x; x >= x_pos; x--){
			m = (y_pos - old_y)/(x_pos - old_x);	//slope of line
   			y = m * x + (old_y - m * old_x);		//y for given x
			if(x < MAP_W - projectile_image.width && x > 0){
				if(terrain[(int)x] <= y){
						//collision has occured durring move
					collision = 1;
					x_pos = (int)x;
					y_pos = (int)y;

					return 1; //collision
				}
			}
			else return -1; //out of bounds
		}
	}



		//test for off screen
		//projectile is below map and within x-boundaries
//need to figure out more precise x-position along map floor
	if(y_pos > MAP_H - projectile_image.height && x_pos < MAP_W-projectile_image.width && x_pos > projectile_image.width){
		y_pos = MAP_H - projectile_image.height;
		collision = 1;
		return collision;
	}

		//projectile is out of bounds
	if(x_pos > MAP_W - projectile_image.width || x_pos < projectile_image.width){
			//kill the projectile somehow
        collision = -1; 		
		return collision;
	}
	




		//check for collisions after move
	if(y_pos >= terrain[x_pos]){

			//there is a collision
		collision = 1;

		while(y_pos != terrain[x_pos] && i <= 100000){

				//find the exact x & y point where the projectile meets the terrain
				//stop if haven't found after 100 tries

			if(y_pos > terrain[x_pos]){
				x_pos -= x_velocity_halfed;
				y_pos -= y_velocity_halfed;
			}
			else if(y_pos < terrain[x_pos]){
				x_pos += x_velocity_halfed;
				y_pos += y_velocity_halfed;
			}
			
			x_velocity_halfed = x_velocity_halfed/2;
			y_velocity_halfed = y_velocity_halfed/2;
			if(x_velocity_halfed == 0){
				x_velocity_halfed = 1;
			}
			if(y_velocity_halfed == 0){
				y_velocity_halfed = 1;
			}

			i++;
		}
		return collision;
	}



	return collision;
}
/////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////
void projectile::draw(UCHAR *dest){
	if(y_pos < MAP_H-projectile_image.height && y_pos > projectile_image.height && x_pos < MAP_W-projectile_image.width && x_pos > projectile_image.width){
		projectile_image.x = x_pos;
		projectile_image.y = y_pos;
 		Draw_Bitmap16(&projectile_image,dest,back_lpitch,RGB16Bit(255,255,255));
	}
}
/////////////////////////////////////////////////////////////