#ifndef PROJECTILE
#define PROJECTILE

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "world.h"
#include "tank.h"

class projectile
{

public:
	projectile(	int x, 
				int y, 
				int velocity, 
				int angle,
				int owner_tank, 
				weaponType type, 
				int target_x=0, 
				int target_y=0
			  );

	int get_x();			//returns the x position of the projectile
	int get_y();			//returns the y position of the projectile
	int get_vx();			//returns the x velocity of the projectile
	int get_vy();			//returns the y velocity of the projectile
	int get_damage();		//returns the damage of the projectile
	int get_radius();		//returns the radius of the explosion on impact
	int get_owner();

	weaponType getWeaponType();
	void set_x(int x);		//sets the x position of the projectile
	void set_y(int y);		//sets the y position of the projectile
	void set_vx(int vx);	//sets the x velocity of the projectile
	void set_vy(int vy);	//sets the y velocity of the projectile
	void set_dammage(int damge);//sets the damage of the projectile
	void set_radius(int r);	//sets the radius of the explosion on impact

	void draw(UCHAR *dest);	//draws the projectile
	int move(int terrain[]); //moves the projectile & detects collisions
	
private:
	int x_pos;				//x position
	int y_pos;				//y position
	int x_velocity;			//x velocity
	int y_velocity;			//y velocity
	int damage;				//maximum damage inflicted by projectile (based on weaponType)
	int radius;				//radius of explosion when projectile hits
	int owner;				//originating tank
	int target_x, target_y;	//target for VICS & HERBS
	
	int sound_id;	//Sound id of this projectile
	DWORD start_time;

	weaponType weapon_type;	//type of weapon
	int draw_state;

	BITMAP_IMAGE projectile_image;
	BITMAP_FILE bitmap_file; //projectile image file
};
#endif