
#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines								//
#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "sound.h"


sound::sound() {
	// initialize directsound
	DSound_Init();



	// load in the digital sound
	sound_ids[NUKE_EXP] = DSound_Load_WAV("sounds/NUKE_EXP.WAV");
	sound_ids[FIRE_WEAPON] = DSound_Load_WAV("sounds/FIRE_WEAPON.WAV");
	sound_ids[NO_AMMO] = DSound_Load_WAV("sounds/NO_AMMO.WAV");
	sound_ids[WEAPON_SWITCH] = DSound_Load_WAV("sounds/WEAPON_SWITCH.WAV");
	sound_ids[LASER_EXP] = DSound_Load_WAV("sounds/LASER_EXP.WAV");
	sound_ids[LGMISSILE_EXP] = DSound_Load_WAV("sounds/LGMISSILE_EXP.WAV");
	sound_ids[MISSILE_EXP] = DSound_Load_WAV("sounds/MISSILE_EXP.WAV");
	sound_ids[LGNUKE_FLY] = DSound_Load_WAV("sounds/LGNUKE_FLY.WAV");
	sound_ids[LGNUKE_EXP] = DSound_Load_WAV("sounds/LGNUKE_EXP.WAV");
	sound_ids[MACHINEGUN_EXP] = DSound_Load_WAV("sounds/MACHINEGUN.WAV");
	sound_ids[PROJECTILE_FLY] = DSound_Load_WAV("sounds/PROJECTILE_FLY.WAV");
	sound_ids[OPEN_WPN_SEL] = DSound_Load_WAV("sounds/OPEN_WPN_SEL.WAV");
	sound_ids[TURRET] = DSound_Load_WAV("sounds/TURRET.WAV");
	sound_ids[PURCHASE_DENY] = DSound_Load_WAV("sounds/PURCHASE_DENY.WAV");
	sound_ids[BG_SOUND] = DSound_Load_WAV("sounds/BG_SOUND.WAV");
	sound_ids[PURCHASE] = DSound_Load_WAV("sounds/PURCHASE.WAV");

}
sound::~sound() {
	// stop all sounds
	DSound_Stop_All_Sounds();

	// delete all sounds
	DSound_Delete_All_Sounds();

	// shutdown directsound
	DSound_Shutdown();

}

int sound::playSound(soundType S, bool replicate, bool repeat) {
//Takes a type of sound and plays it.
	
	if(!(((int)S >=0) && ((int)S <MAX_SOUNDS)))
		return -1;
	
	if(replicate) {
		int i = DSound_Replicate_Sound(S);
		DSound_Play(i);
		return i;
	}
	if(repeat) {
		DSound_Play(S,DSBPLAY_LOOPING);

	}
	else {
		DSound_Play(sound_ids[S]);
		return S;
	}



}

void sound::stopSound(int S)  {
//Stops playing a sound.
	DSound_Stop_Sound(S);

}
