#ifndef TANK
#define TANK

#include <vector>
#include <string> 
#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "main.h"
#include "world.h"
#include "weapon.h"


using namespace std;

class tank
{
public:
	tank();
	tank(int color);
	int pos_x,pos_y;
	int width, height;
	int angle; //0 points to left.  90 is straight up.  180 is right.
	int velocity; //0 to 100
	int vy; //Velocity for dropping
	BITMAP_IMAGE arrowImage;
	
	long credits; //Money
	int pos_arrow_y;//arrow y position
	int vy_arrow;	//velocity for dropping arrow
	bool drewArrow;
	int TOP_OF_ARROW;

	int *terrain_y;
	string name;
	int tankColor;	//RED, GREEN, BLUE, YELLOW, ORANGE, GREY, WHITE, or CYAN
	int tank_color_red, tank_color_green, tank_color_blue; //Color Components
	int health;
	int damageDoneInTurn;	//Total damage done to a tank

	BITMAP_IMAGE tankImg;
	POLYGON2D barrel;
	VERTEX2DF *barrelVertices;

	vector<weapon> wpnList;
	weaponType currentWeapon;

	void set_x(int x);	//Set tank location
	void set_y(int y);
	int getWidth();		//Tank bitmap info
	int getHeight();
	int getAngle();		//Retrieve tank info
	int getVelocity();
	int getX();			//Get tank Info
	int getY();
	void reset();		//Clear tank for re-entry
	void draw(UCHAR *dest); //Draw a tank
	bool drop();			//Drop the tank to the terrain
	void clear_landing();	//Smooth out resting location for tank
	void barrelLeft();		//Move barrel left/right
	void barrelRight();
	void getBarrelLocation(int &x, int &y); //Get the x,y of the barrel tip
	void barrelDraw(UCHAR *dest); //Draws barrel on top of the tank

	void velocityIncrease();	//Power up/down
	void velocityDecrease();
	bool fireWeapon();
	int getHealth();
	void setHealth(int health_value);

	void damageTank(int damge); //Subtract an amount of health from the tank

	weaponType getCurrentWeapon();	//Retrieves the current weapon
	void setCurrentWeapon(weaponType weaponOfChoice);

	void displayHeader(int x, int y); //Displays tank information at the given point
	
	bool hasExploded(); //returns whether or not a tank has exploded
	void explode();		//sets exploded to true;
	bool isDead();	//Returns whether or not a tank is dead.

	bool endOfTurn();
	bool drawTankDamage();

	void dropArrow();	//move the arrow
	void drawArrow();	//Draw the arrow

private:
	bool exploded; //True if tank is dead && exploded. False otherwise.
	int timesDamageDisplayed;//Offset of the damage indicator
	BITMAP_IMAGE skullImage;
};

#endif
