#define WIN32_LEAN_AND_MEAN  



#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines
#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "main.h"
#include "weapon.h"
#include "rndalgor.h"


/////////////////////////////////////////////////////////////


weapon::weapon(weaponType type, int A) {

	ammo = A;
	wpnType = type;

	int no_frames, i;
	BITMAP_FILE weaponIconFile;

	switch(wpnType){
		case MISSILE:		//load the missle icon
						Load_Bitmap_File(&weaponIconFile, "icons\\missile.bmp"); //load the file
						break;
		case LGMISSILE:	//load the large missile icon
						Load_Bitmap_File(&weaponIconFile, "icons\\lgmissile.bmp"); //load the file
						break;
		case NUKE:		//load the nuke icon
						Load_Bitmap_File(&weaponIconFile, "icons\\nuke.bmp"); //load the file
						break;
		case LGNUKE:
						Load_Bitmap_File(&weaponIconFile, "icons\\lgnuke.bmp"); //load the file
						break;
		case CLUSTER:
						Load_Bitmap_File(&weaponIconFile, "icons\\cluster.bmp"); //load the file
						break;
		case MEGACLUSTER:
						Load_Bitmap_File(&weaponIconFile, "icons\\megacluster.bmp"); //load the file
						break;
		case DIGGER:
						Load_Bitmap_File(&weaponIconFile, "icons\\digger.bmp"); //load the file
						break;
		case LGDIGGER:
						Load_Bitmap_File(&weaponIconFile, "icons\\lgdigger.bmp"); //load the file
						break;
		case VICKS:
						Load_Bitmap_File(&weaponIconFile, "icons\\vicks.bmp"); //load the file
						break;
		case HERBS:
						Load_Bitmap_File(&weaponIconFile, "icons\\herbs.bmp"); //load the file
						break;
		case LASER:
						Load_Bitmap_File(&weaponIconFile, "icons\\laser.bmp"); //load the file
						break;
		default:
						Load_Bitmap_File(&weaponIconFile, "icons\\blank.bmp"); //load the file
						break;
	}
	Create_Bitmap(&weaponIcon, 650,5,48,50,16);
	Load_Image_Bitmap16(&weaponIcon, &weaponIconFile, 0,0, BITMAP_EXTRACT_MODE_ABS);
	Unload_Bitmap_File(&weaponIconFile);

}
/////////////////////////////////////////////////////////////
int weapon::getAmmo() {
	return ammo;
}

void weapon::setAmmo(int A) {
	if(A >=0)
		ammo = A;
}

void weapon::addAmmo(int A){
	ammo += A;
}

weaponType weapon::getWpnType() {
	return wpnType;
}

void weapon::init(weaponType type, int A) {
	wpnType = type;
	ammo = A;

}

void weapon::drawIcon(){
	Draw_Bitmap16(&weaponIcon,back_buffer,back_lpitch,1);

	sprintf(buffer, "%d", getAmmo());
	if(getAmmo() > 100){
		Draw_Text_GDI(buffer, 680, 35, RGB(255,255,255), lpddsback);	
	}
	else if(getAmmo() > 10){
		Draw_Text_GDI(buffer, 687, 35, RGB(255,255,255), lpddsback);	
	}
	else{
		Draw_Text_GDI(buffer, 694, 35, RGB(255,255,255), lpddsback);	
	}

}

/////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////
weapon::~weapon() {

}
/////////////////////////////////////////////////////////////