#define WIN32_LEAN_AND_MEAN  

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>		// Time routines
#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "main.h"
#include "weaponbuy.h"
#include "weapon.h"
#include "tank.h"


////////////////////////////////////////////////////////////////////////////
weaponBuy::weaponBuy(){

	DDraw_Init(MAP_W, MAP_H, 16, 1);
	
	//create & load the bitmap file
	BITMAP_FILE weaponBuyFile;
	Load_Bitmap_File(&weaponBuyFile, "graphics/wpnselection.bmp"); //load the file

		//create the bitmap image
	Create_Bitmap(&weaponBuyImage, 0,0,800,600,16);

		//load the bitmap file into image
	Load_Image_Bitmap16(&weaponBuyImage, &weaponBuyFile, 0,0, BITMAP_EXTRACT_MODE_ABS);
	Unload_Bitmap_File(&weaponBuyFile);

	num_players = tankList.size();
	currentPlayer = 0;

	lastClickTime = 0;

	int y_pos = 85;

	for(int i=MISSILE; i<=LASER; i++){
		ammoDrawY[i] = y_pos;
		y_pos += 46;
	}
	
	DInput_Init();// initialize directinput
	
	DInput_Init_Keyboard(); // acquire the keyboard only
			
	// set clipping region
	min_clip_x = 0;
	max_clip_x = screen_width - 1;
	min_clip_y = 0;
	max_clip_y = screen_height - 1;
	
	DDraw_Lock_Back_Surface();
}




////////////////////////////////////////////////////////////////////////////
bool weaponBuy::updateScreen(){
	//returns true when done, otherwise returns false

	int x1 = 328, x2 = 380;

	Start_Clock();

	DDraw_Fill_Surface(lpddsback, 0);
	
	// lock back buffer and copy background into it
	DDraw_Lock_Back_Surface();

	draw();		//draw the weapon selection screen


	if(Get_Clock() - lastClickTime > 500){
				//get mouse input

		if(buttons & MK_LBUTTON){

			if(checkMouse(x1, x2, 77, 113)){
				//MISSILE
				if(tankList[currentPlayer].credits >= 100) {
					tankList[currentPlayer].wpnList[MISSILE].addAmmo(10);
					tankList[currentPlayer].credits -=100;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 116, 165)){
				//LGMISSILE
				if(tankList[currentPlayer].credits >= 500) {
					tankList[currentPlayer].wpnList[LGMISSILE].addAmmo(10);
					tankList[currentPlayer].credits -=500;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 166, 204)){
				//NUKE
				if(tankList[currentPlayer].credits >= 5000) {
					tankList[currentPlayer].wpnList[NUKE].addAmmo(1);
					tankList[currentPlayer].credits -=5000;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 207, 258)){
				//LGNUKE
				if(tankList[currentPlayer].credits >= 10000) {
					tankList[currentPlayer].wpnList[LGNUKE].addAmmo(1);
					tankList[currentPlayer].credits -=10000;
					worldSounds->playSound(PURCHASE);				
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 262, 300)){
				//DIGGER
				if(tankList[currentPlayer].credits >= 100) {
					tankList[currentPlayer].wpnList[DIGGER].addAmmo(1);
					tankList[currentPlayer].credits -=100;
					worldSounds->playSound(PURCHASE);				
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 301, 350)){
				//LGDIGGER
				if(tankList[currentPlayer].credits >= 500) {
					tankList[currentPlayer].wpnList[LGDIGGER].addAmmo(1);
					tankList[currentPlayer].credits -=500;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 351, 396)){
				//CLUSTER
				if(tankList[currentPlayer].credits >= 2000) {
					tankList[currentPlayer].wpnList[CLUSTER].addAmmo(1);
					tankList[currentPlayer].credits -=2000;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 397, 442)){
				//MEGACLUSTER
				if(tankList[currentPlayer].credits >= 6000) {
					tankList[currentPlayer].wpnList[MEGACLUSTER].addAmmo(1);
					tankList[currentPlayer].credits -=6000;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 443, 489)){
				//VICKS
				if(tankList[currentPlayer].credits >= 6000) {
					tankList[currentPlayer].wpnList[VICKS].addAmmo(1);
					tankList[currentPlayer].credits -=6000;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 490, 535)){
				//HERBS
				if(tankList[currentPlayer].credits >= 15000) {
					tankList[currentPlayer].wpnList[HERBS].addAmmo(1);
					tankList[currentPlayer].credits -=15000;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			else if(checkMouse(x1, x2, 536, 573)){
				//LASER
				if(tankList[currentPlayer].credits >= 500) {
					tankList[currentPlayer].wpnList[LASER].addAmmo(1);
					tankList[currentPlayer].credits -=500;
					worldSounds->playSound(PURCHASE);
				} else 
					worldSounds->playSound(PURCHASE_DENY, false);
			}
			lastClickTime = Get_Clock();//Click was made.  Get its time
		}
	}
		//"Ready" button is clicked

	if(checkMouse(22, 200, 515, 573)){
		if(!buttonClicked && (buttons & MK_LBUTTON)){
			buttonClicked = true;
			if(next()){
				return true;
			}
		}
	}
	else
		buttonClicked = false;

	// unlock back surface
	DDraw_Unlock_Back_Surface();


	// flip the surfaces
	DDraw_Flip();

	Wait_Clock(50);

	return false;
}

////////////////////////////////////////////////////////////////////////////
void weaponBuy::initialize(){
	currentPlayer = 0;
	num_players = tankList.size();
}


//Private Member Functions
////////////////////////////////////////////////////////////////////////////
void weaponBuy::draw(){
	//draws the weapon selection screen

	int i;
	int ammoDrawX = 260;

	Draw_Bitmap16(&weaponBuyImage,back_buffer,back_lpitch,0);

	for(i=MISSILE; i<=LASER; i++){
		sprintf(buffer, "%d", tankList[currentPlayer].wpnList[i].getAmmo());
		Draw_Text_GDI(buffer, ammoDrawX, ammoDrawY[i], RGB(255,255,255), lpddsback);	
	}
	sprintf(buffer, "%s", tankList[currentPlayer].name.c_str());
	Draw_Text_GDI(buffer, 60, 128, RGB(255,255,255), lpddsback);	

	sprintf(buffer, "$ %d", tankList[currentPlayer].credits);
	Draw_Text_GDI(buffer, 60, 210, RGB(255,255,255), lpddsback);	

}


////////////////////////////////////////////////////////////////////////////
bool weaponBuy::next(){
	//selects next player - returns true if there are no more players



	currentPlayer++;
	if(currentPlayer >= num_players){
		return true;
	}
	return false;
}
////////////////////////////////////////////////////////////////////////////
bool weaponBuy::checkMouse(int x1, int x2, int y1, int y2){
	//returns true if mouse is between x1, x2 and y1, y2
	if(MOUSE_X > x1 && MOUSE_X < x2 && MOUSE_Y > y1 && MOUSE_Y < y2)
		return true;
	else
		return false;
}