#ifndef WORLD
#define WORLD

// DEFINES ////////////////////////////////////////////////
extern enum weaponType {MISSILE=0, LGMISSILE, NUKE, LGNUKE, DIGGER, LGDIGGER, CLUSTER, MEGACLUSTER, VICKS, HERBS, LASER, PARTICLE};
extern enum playerState {AIMING=0, FIRED, DAMAGE_DISPLAY, TANK_EXPLOSIONS, SELECT_NEXT_PLAYER};
#define NUM_WEAPONS 14
#define MAP_W 800
#define MAP_H 600

// INCLUDES ////////////////////////////////////////////////
#include "T3DLIB1.h" // game library includes
#include "T3DLIB2.h"
#include "T3DLIB3.h"

#include "main.h"
#include "tank.h"
#include "projectile.h"
#include "explosion.h"
#include <vector>
using namespace std;


class world {
public:
	world();
	~world();
	void create();					//Initialize world
	void generateTerrain();			
	void smoothTerrain(int left, int right);
	void drawTerrain(UCHAR *dest);
	void generateBG();
	bool updateScreen();
	void placeTanks();
	void kbInput();
	int* getTerrain();
	void screenHeader();
	void endOfTurn();
	void AddProjectile(int x,int y,int vel,int ang, int owner_tank, weaponType type);
	void updateProjectiles();
	void addExplosion(weaponType wpn, int x, int y, int r);
	void updateExplosions();
	void damageDisplayHandler();
	void tankExplosionHandler();
	bool fire();
	int getCurrentPlayerIndex();
	void setCurrentPlayerWeapon(weaponType weapon);
	bool isRoundOver();
	void roundOver();
	weaponType showMenu();

protected:
	int frameRate;
	int frames;
	DWORD start_time;
	explosion blah;
	
	float g_nGradient[MAP_W];	// Gradient of terrain at each x value
	int terrain_y[MAP_W];
	int terrain_color_red, terrain_color_green, terrain_color_blue;
	bool showWeaponSelectMenu;

	float gravity_force;  // gravity
	float wind_force; // wind resistance
	int num_players;
	int current_player;
	BITMAP_IMAGE background_bmp;      // holds the background
	BITMAP_IMAGE gradient_bmp;
	
	vector<projectile> projList;
	vector<explosion> expList;
	DWORD last_shot;
	
	playerState player_state;
	bool round_over;

	BITMAP_IMAGE menuImage;
	weaponType weaponSelect;
	
};

#endif